#include "SevSeg.h" //Include thư viện SevSeg

SevSeg myDisplay; // Khai báo biến myDisplay là đối tượng của thư viện SegSev

int bientro = A0;
/* NEW */

int maxTime = 60*60 - 1;// 59 phút 59 giây.
int time; // Biến "Quỹ thời gian". 
int defaultTime = 90; // Mặc định tôi đặt là 90 giây
int second,minute;// Biến giây và biến phút sẽ được tính từ biến "Quỹ thời gian"
unsigned long milli,milli2; // Biến milli dùng để lưu lại THỜI ĐIỂM VỪA THỰC HIỆN LỆNH XUẤT RA ĐỒNG HỒ. Biến milli2 dùng để lưu lại THỜI ĐIỂM CUỐI CÙNG NHẤN NÚT BẤM
boolean startCounting = false; // Biến này dùng để. Mặc định là chưa đếm
char buf[5]; //Chuỗi buf có độ dài tối đa là 4 (xem bài char để rõ). Chuỗi buf có nhiệm vụ là nhận giá trị cuối cùng (Đã được định dạng thời gian) trước khi chuyển cho đối tượng SegSev để xuất ra Module 4 LED số 8

int buttonPin[3]= {A3,A2,A1}; // Mảng lưu chân các button. Do 12 chân digital đã được sử dụng để xử lý Module 4 LED nên mình mới sử dụng chân Analog, ngoài ra bạn có thể sử dụng chân Digital cho việc này
int button[3]; // Mảng lưu giá trị các button (HIGH, LOW)

int speakerPin = A4; // Chân nối tới 1 chân của loa. Do 12 chân digital đã được sử dụng để xử lý Module 4 LED nên mình mới sử dụng chân Analog, ngoài ra bạn có thể sử dụng chân Digital cho việc này
/* Hết NEW */
void setup() { //Hàm Setup
  Serial.begin(9600);//Bật cổng Serial ở mức Baudrate là 9600
  Serial.println("Ready");
  int displayType = COMMON_ANODE; // CÁI NÀY VÔ CÙNG QUAN TRỌNG, nếu người ta bán cho bạn một Module LED 8 đoạn chung cực dương thì bạn không cần thay đổi dòng này. Còn nếu họ bán một Module LED 8 đoạn chung cực âm cho các bạn thì bạn cần thay đổi là COMMON_CATHODE. Và nếu người bán không nói cho bạn hoặc bạn quên không hỏi thì cũng không sao, cứ đặt như thế này và lắp mạch nếu không chạy đúng như những gì đoạn code này cần thực hiện thì bạn chỉ cần thay nó là COMMON_CATHODE thôi!
  int digit1 = 8; //Pin 12 led 7 đoạn
  int digit2 = 12; //Pin 9 led 7 đoạn
  int digit3 = 13; //Pin 8 led 7 đoạn 
  int digit4 = 2; //Pin 6 led 7 đoạn

  int segA = 9; //Pin 11 led 7 đoạn
  int segB = 11; //Pin 7 led 7 đoạn
  int segC = 4; //Pin 4 led 7 đoạn
  int segD = 6; //Pin 2 led 7 đoạn
  int segE = 7; //Pin 1 led 7 đoạn
  int segF = 10; //Pin 10 led 7 đoạn
  int segG = 3; //Pin 5 led 7 đoạn
  int segDP= 5; //Pin 3 led 7 đoạn

  int numberOfDigits = 4; // số dấu chấm

  myDisplay.Begin(displayType, numberOfDigits, digit1, digit2, digit3, digit4, segA, segB, segC, segD, segE, segF, segG, segDP); // Bắt đầu cho phép giao tiếp Module LED 7 đoạn với Arduino
  
  myDisplay.SetBrightness(100); //điều chỉnh độ sáng của Module LED

  /* NEW */
  // pinMode các chân của button là INPUT
  for (int i = 0;i < 3; i++) { //Chạy từ 0 --> 2
    pinMode(buttonPin[i], INPUT);
  }
  milli = milli2 = millis(); // Cập nhập cả 2 thời điểm
  time = defaultTime;
  /* hết NEW */
}

void loop(){
  myDisplay.SetBrightness(getBrightness()); //độ sáng
  
  /* NEW */
  if (millis() - milli2 > 300) { //Cứ sau mỗi 300 mili giây là đọc tất cả giá trị button
    for (int i = 0;i < 3; i++){
      button[i] = digitalRead(buttonPin[i]);
      Serial.print(button[i]); //Debug
    }
    Serial.println();
    /*
      Bây giờ chúng ta sẽ thiết đặt các lệnh, gợi ý, các bạn đặt những lệnh nào sử dụng nhiều nút bấm lên trước
       Tôi đặt mặc định như sua:
         - Nhấn cả 2 phím button[0] và button[2] sẽ ngừng/tiếp tục đếm ngược --> delay(500) miligiây để tạo hiệu ứng
         - Nhấn button[1] sẽ reset về giá trị ban đầu và ngừng đếm ngược --> delay(500) miligiây để tạo hiệu ứng
         - Nhấn button[0] để giảm "Quỹ thời gian" đi 10 giây
         - Nhấn button[2] để tăng "Quỹ thời gian" thêm 10 giây
    */
    if (button[0] && button[2]) {
      startCounting = !startCounting;//Thay đổi trạng thái kiểu toogle giữa HIGH và LOW
      delay(500);
    } else if (button[1]) {
      time = defaultTime;// Đặt mặc định
      startCounting = false;
      delay(500);
    } else if (button[0]) {
      time = max(0,time-10);
    } else if (button[2]) {
      time = min(maxTime,time+10);      
    }
    
    milli2 = millis();//Cập nhập lại thời điểm
  }
  second = time % 60;
  minute = time / 60;
  sprintf(buf, "%02d%02d", minute,second); // Hàm sprintf là một hàm của C, bạn tham khảo địa chỉ http://www.cplusplus.com/reference/cstdio/sprintf/ Tôi dùng nó để định dạng lại giá trị trước khi xuất ra màn hình. Bởi vì các biến minute và second là các biến kiểu số nguyên => không thể xuất được. Vì vậy tôi định dạng lại nó để có được mạng chuỗi dạng (mmss) (mm = minute, ss = second) để xuất ra được Module 4 LED số 8
  myDisplay.DisplayString(buf, 0b00000010); // Thể hiện chữ AbcD ra bảng LED, và dãy số 0b00001000 là vị trí dấu chấm. Bạn hãy thử thay những số 0 bằng số 1 hoặc ngược lại để kiểm nghiệm
  if (startCounting && time > 0 && (millis() - milli) > 1000 ) {
    /*
      Còn đếm ngược khi:
        1. Được phép đếm
        2. Quỹ thời gian lớn hơn 0
        3. Cách 1 giây từ THỜI ĐIỂM VỪA THỰC HIỆN LỆNH XUẤT RA ĐỒNG HỒ
    */
    milli = millis();
    time -= 1;
  }
  
  if (time == 0) { // Quỹ thời gian đã cạn, bây giờ boom sẽ nổ! (đùa thôi, loa sẽ kêu)
    tone(speakerPin,3200); //Phát ra âm thanh ở tần số 3200 Hz, bạn có thể thay đổi nó, miễn nó nằm trong ngưỡng nghe được của tai.
  } else {
    noTone(speakerPin); // Tắt loa vì Quỹ thời gian vẫn còn
  }
  
  delay(5);
  /* hết NEW */
  
}

int getBrightness() { // Hàm đọc giá trị độ sáng từ biến trở
  int value = analogRead(bientro); // Đọc giá trị biến trở và đưa vào biến value
  value = map(value,0,1023,0,100); // Chuyển đổi giá trị trong thang đo 0-1023 về thang đo 0 - 180
  /* NEW */
  Serial.println(value);
  /* hết NEW*/
  return value; // Trả về giá trị độ sáng
}
